Subject: [bug#28531] [PATCH] gnu: Add vcsh.

From: Stefan Reichör <[email-masked]>
Date: Sat, 23 Sep 2017 20:10:45 +0200

Hi Ludo,

> Hello,
>
> Stefan Reichör <[email-masked]> skribis:
>
>>> Hi Stefan,
>>>
>>> Stefan Reichör <[email-masked]> skribis:
>>>
>>>> * gnu/packages/version-control.scm (vcsh): New variable.
>>>
>>> Pushed with the minor changes below (the first sentence of the
>>> description looked awkward to me).
>>>
>>> Note that vcsh takes ‘git’ from $PATH.  I wonder if we should keep it
>>> this way, or if we should hard-code the absolute file name to ‘git’ so
>>> that it always works.
>>>
>>> Thoughts?
>>
>> I don't think that it is desirable to change all external tool
>> invocations for programs in Guix. I am currently preparing the tool
>> atool that has to invoke a lot of archivers.
>
> We always have a choice between “static binding” (where we hard-wire a
> tool and its dependencies) and “late binding” (where the dependencies
> are searched for at run time.)
>
> Most of the time in Guix we favor static binding: it makes sure that (1)
> programs work out of the box, regardless of what happens to be already
> installed on your system, and (2) that the program will behave the same
> on all systems since its behavior does not depend on external state.
>
> There are exceptions where we want dynamic binding, for instance for
> plugins or optional/soft dependencies.
>
> The case of ‘vcsh’ is borderline.  I have a slight preference to
> hardwire the dependency on Git (after all, someone might want to use
> vcsh without having installed Git before), but I’m open to other
> arguments.
>
> Thoughts?

Thanks for the explaination. I see the benefit of the static binding.
The good thing is that the package versions are reproducable.
However, I am used to the way it works on other systems. There is almost
always the search path used to start other programs.

And to make it even more complicated, I still use Ubuntu and install
some tools using Guix. So it is even possible that I use vcsh from Guix
and git from Ubuntu.

I took a look at the vcsh script. git is hardcoded in many places there.
Patching it to have static binding seems to be complicated. The only
sane solution would be to change the script and make git configurable
and try to make this change upstream. However I am not really keen on
doing this kind of work...

Or do you have another idea how the static binding should be accomplished?

Stefan.

> Thanks,
> Ludo’.
> PS: Please preserve Cc:.
o.k. - I interpreted the Cc: "[email-masked]" as flag that
the bug is closed and was unsure what will happen when I respond to the
closed bug...